# coding: utf-8

require 'chef/knife'
require 'knife-hitori'

class Chef
  class Knife
    module HitoriBase
      def update_environment(env)
        Chef::Config[:environment] = nil
        Chef::Config[:solo_environment] = env
        %w(data_bag_path settings_path encrypted_data_bag_secret).each do |name|
          name = name.to_sym
          tpl_name = "#{name}_tpl".to_sym
          if Chef::Config[tpl_name]
            Chef::Config[name] = sprintf(Chef::Config[tpl_name], env)
          end
        end
      end
    end
  end
end