# coding: utf-8

require 'chef/knife/hitori_base'
require 'chef/knife/hitori_prepare'
require 'chef/knife/hitori_cook'
require 'chef/knife/hitori/run_list_options'


class Chef
  class Knife
    class HitoriBootstrap < Knife
      banner 'knife hitori bootstrap (options)'
      include HitoriBase
      include RunListOptions

      def load_deps
        Chef::Knife::HitoriPrepare.load_deps
        Chef::Knife::HitoriCook.load_deps
        super
      end

      def run
        update_environment(config[:environment]) if config[:environment]
        hitori_prepare = Chef::Knife::HitoriPrepare.new
        hitori_prepare.config = config.dup
        hitori_prepare.run

        hitori_cook = Chef::Knife::HitoriCook.new
        hitori_cook.config = config.dup
        hitori_cook.run_remote([hitori_prepare.server])
      end
    end
  end
end

