# coding: utf-8

module KnifeHitori
  module CryptUtil
    require 'chef/encrypted_data_bag_item'

    # @param [Hash] data
    # @param [String] secret
    # @return [String]
    def decrypt(data, secret)
      Chef::EncryptedDataBagItem::Decryptor.for(data, secret.strip).for_decrypted_item
    end

    # @param [String] data
    # @param [String] secret
    # @return [Hash]
    def encrypt(data, secret)
      Chef::EncryptedDataBagItem::Encryptor.new(data, secret.strip).for_encrypted_item
    end
  end
end

