# coding: utf-8

require 'rubygems'
require 'chef'
require 'chef/knife'
require 'chef/encrypted_data_bag_item'
require 'json'
require 'fileutils'
require 'optparse'


options = {}
opt = OptionParser.new
# opt.on("-k SecretKey") {|v| options[:key] = v}
opt.on('-j JSON') {|v| options[:data] = v}
opt.on('-b BagName') {|v| options[:bag] = v}
opt.on('-i ItemName') {|v| options[:item] = v}
opt.on('--show') {|_| options[:show] = true}
opt.permute!(ARGV)

unless (options[:data] or options[:show]) and options[:bag] and options[:item]
  puts opt.help
  exit
end

class Fixnum
  def to_json(options = nil)
    to_s
  end
end

knife = Chef::Knife.new
knife.configure_chef

# http://lists.opscode.com/sympa/arc/chef/2012-11/msg00402.html

Chef::Config[:solo] = true
data_bag_path = Chef::Config[:data_bag_path]
secret = Chef::EncryptedDataBagItem.load_secret(Chef::Config[:encrypted_data_bag_secret])

if options[:show]
  spr_creds = Chef::EncryptedDataBagItem.load(options[:bag], options[:item], secret)
  puts JSON.pretty_generate(spr_creds.to_hash)
else
  data = nil
  File.open(options[:data], "r") do |f|
    data = JSON.parse(f.read)
  end

  encrypted_data = Chef::EncryptedDataBagItem.encrypt_data_bag_item(data, secret)

  bag_dir = "#{data_bag_path}/#{options[:bag]}"
  FileUtils.mkpath(bag_dir)
  File.open("#{bag_dir}/#{options[:item]}.json", 'w') do |f|
    f.print encrypted_data.to_json
  end
end
