
require 'rubygems'
require 'chef'
require 'chef/knife'
require 'chef/encrypted_data_bag_item'
require 'json'
require 'optparse'
require_relative '../cookbooks/cryptfile/libraries/crypt_util'


options = {}
opt = OptionParser.new
opt.on('-i input_file') {|v| options[:input_file] = v}
opt.on('-d') {|_| options[:mode] = :decrypt}
opt.on('-e') {|_| options[:mode] = :encrypt}
opt.on('-k secret_file') {|v| options[:secret_file] = v}
opt.permute!(ARGV)

unless options[:input_file] and options[:mode]
  puts opt.help
  exit
end

class Fixnum
  def to_json(options = nil)
    to_s
  end
end

knife = Chef::Knife.new
knife.configure_chef
Chef::Config[:solo] = true

# http://lists.opscode.com/sympa/arc/chef/2012-11/msg00402.html

secret_file = options[:secret_file] || Chef::Config[:encrypted_data_bag_secret]
secret = File.read(secret_file)
data = File.read(options[:input_file])

case options[:mode]
  when :encrypt
    print JSON.dump(encrypt(data, secret))
  when :decrypt
    print decrypt(JSON.parse(data), secret)
end
